package net.sf.itcb.common.portlet.util;

import java.util.Map;

import javax.portlet.PortletRequest;

import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.context.SecurityContext;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;

/**
 * This class defines in which portal the portlet is launched and delegate to the dedicated {@link PortalAdapter} class the transformation of user... data.<br/>
 * Mapping is done by the map <code>portalAdapters</code> injected by Spring.
 * 
 * This class is not finished yet such as the user management.
 * 
 * @author Pierre Le Roux
 */
public class PortalAdapterUtilImpl implements PortalAdapterUtil {

	private static final long serialVersionUID = 1L;
	
	private Map<String, PortalAdapter> portalAdapters;
	
	public PortalAdapterUtilImpl(Map<String, PortalAdapter> portalAdapters) {
		this.portalAdapters = portalAdapters;
	}

	public void storeUserInContext(PortletRequest request) {
		PortalAdapter portalAdapter = portalAdapters.get(request.getClass().getName());
		
		SecurityContext initialSecurityContext = SecurityContextHolder.getContext();
		
		UserDetails user = portalAdapter.getUser(request);
		if(user != null) {
			initialSecurityContext.setAuthentication(new UsernamePasswordAuthenticationToken(user.getUsername(),user.getPassword(), user.getAuthorities()));
			SecurityContextHolder.setContext(initialSecurityContext);
		}
	}

}
