package net.sf.itcb.common.portlet.vaadin.page;

import net.sf.itcb.common.portlet.vaadin.PageMappingProcessor;

import com.vaadin.ui.VerticalLayout;

/**
 * Each page has to extend this class
 * 
 * @author Pierre Le Roux
 *
 */
public abstract class AbstractItcbPortletPage extends VerticalLayout {

	private static final long serialVersionUID = 1L;

	private PageMappingProcessor pageMappingProcessor;
		
	public void setPageMappingProcessor(PageMappingProcessor pageMappingProcessor) {
		this.pageMappingProcessor = pageMappingProcessor;
	}
	
	public PageMappingProcessor getPageMappingProcessor() {
		return pageMappingProcessor;
	}
	
	public void initPage() {
		removeAllComponents();
		setMargin(false);
		setSpacing(false);
		try {
			defineContentDelegate();
		}
		catch(Exception e) {
			handleException(e);
		}
	}
	
	protected abstract void defineContentDelegate() throws Exception;
	
	protected void handleException(Exception e) {
		// TODO Handle with an ExceptionHandler
	}
   	
}

