package net.sf.itcb.common.portlet.vaadin.validator;

import com.vaadin.data.Validator;
/**
 * Example of a validator for vaadin forms
 * Generic Validators will be created here.
 * 
 * @author Pierre Le Roux
 *
 */
public class IntegerValidator implements Validator {
    	private static final long serialVersionUID = 1L;
        private String message;

        public IntegerValidator(String message) {
            this.message = message;
        }

        public boolean isValid(Object value) {
            if (value == null || !(value instanceof String)) {
                return false;
            }
            try {
                Integer.parseInt((String) value);
            } catch (Exception e) {
                return false;
            }
            return true;
        }

        public void validate(Object value) throws InvalidValueException {
            if (!isValid(value)) {
                throw new InvalidValueException(message);
            }
        }

    }